/********************************************************************
* heuristic.h                                                       *
*********************************************************************
* Written by Mike Chase                                             *
* Written on February 18, 2006                                      *
*********************************************************************
* Purpose: Allow various heuristics to be used in the schedulers    *
********************************************************************/

#ifndef _HEURISTIC_H_
#define _HEURISTIC_H_


// Heuristics for finding the best instruction
#define HEURISTIC_CRITICAL_PATH        0
#define HEURISTIC_DECISIONTREE         1
#define HEURISTIC_SHIEH_PAPACHRISTOU   2
#define HEURISTIC_SHIEH_PAPACHRISTOU_2 3
#define HEURISTIC_SHIEH_PAPACHRISTOU_3 4
#define HEURISTIC_EST                  5
#define HEURISTIC_BEST                 6
#define	HEURISTIC_SIDE_EXIT_FIRST	   7
#define HEURISTIC_DHASY1               8
#define HEURISTIC_DHASY2               9
#define HEURISTIC_DHASY3               10
#define HEURISTIC_WEIGHTED_ESTIMATE    11
#define HEURISTIC_NUM_HEURISTICS       12

int	findBestInstruction( LS_type *L, int* room, int currentTime, int heuristic );
int better( LS_type *L, int v1, int v2, int currentTime, int heuristic );

void setLSHeuristic( int heuristic );
void setOptHeuristic( int heuristic );
int getLSHeuristic( );
int getOptHeuristic( );

#endif
