#include <assert.h>
#include "global.h"
#include "pendingList.h"


LISTNODE *head = NULL, *tail = NULL;

void createPendingList()
{
    head = NULL;
    tail = NULL;
}

/*
 * Delete everything on the list
 */
void deletePendingList()
{
	LISTNODE* temp;

	while( head != NULL ) {
		temp = head;
		head = head->next;
		free( temp );
	}

	tail = NULL;
}

/*
 * Insert an item on the back of the list
 */
void addToBackOfPendingList( int instruction, int type )
{
	LISTNODE *newnode;

	// Make a new node
	newnode = (LISTNODE *)calloc(sizeof(LISTNODE), 1);
if( newnode == NULL ) {
   printf("error: addToBackOfPendingList: out of memory\n");
}
	newnode->next = NULL;
	newnode->instruction = instruction;
	newnode->type = type;

	// Add to the list
	if( head == NULL ) {
		// First item on the list
		head = newnode;
		tail = head;
	}
	else {
		// Tail is non-null
		tail->next = newnode;
		tail = newnode;
	}
}

/*
 * Return true if the list is empty; false otherwise
 */
BOOL isPendingListEmpty()
{
	if( tail == NULL )
		return TRUE;
	return FALSE;
}

/*
 * Remove an item from the list
 */
void removeFromPendingList( int instruction )
{
	LISTNODE *cur, *prev;

	cur = head;
	prev = NULL;

	while( cur != NULL ) {
		if( cur->instruction == instruction ) {
			if( cur == head ) {
				// First item; doesn't change tail (unless head = tail)
if( cur == NULL ) {
   printf("error (a): cur == NULL in removeFromPendingList\n");
}
				head = cur->next;
				//free( cur );
			}
			else if( cur == tail ) {
				// Last item (we know that there's at least one previous)
if( prev == NULL ) {
   printf("error (b): prev == NULL in removeFromPendingList\n");
}
				prev->next = NULL;
				tail = prev;
				//free( cur );
			}
			else {
				// Neither first nor last
if( prev == NULL ) {
   printf("error (c): prev == NULL in removeFromPendingList\n");
}
if( cur == NULL ) {
   printf("error (d): cur == NULL in removeFromPendingList\n");
}
				prev->next = cur->next;
				//free( cur );
			}

			// We may have emptied the list; make sure tail is NULL as well
			if( head == NULL ) {
				tail = NULL;
			}

			return;
		}

		prev = cur;
if( cur == NULL ) {
   printf("error (e): cur == NULL in removeFromPendingList\n");
}
		cur = cur->next;
	}
}

LISTNODE* getPendingListHead()
{
	return head;
}

LISTNODE* getPendingListTail()
{
	return tail;
}
