#ifndef _PENDINGLIST_H_
#define _PENDINGLIST_H_

#define INSTRUCITON_TYPE_UNKNOWN 0
#define INSTRUCTION_TYPE_PIPELINED 1 // An instruction delayed due to pipeline reasons
#define INSTRUCTION_TYPE_SERIAL 2 // An instruction delayed due to needing serial access
#define INSTRUCTION_TYPE_DELAYS_SERIAL 3 // Issuing this instruction now will delay a serial instruction later

/*
 * Node in the pending list
 */
typedef struct listnode {
    int	instruction; // The instruction number
	int type; // One of the three constants above
    struct listnode *next;
} LISTNODE;


void createPendingList();
void deletePendingList();
void addToBackOfPendingList( int instruction, int type );
BOOL isPendingListEmpty();
void removeFromPendingList( int instruction );
LISTNODE* getPendingListHead();
LISTNODE* getPendingListTail();

#endif

