/********************************************************************
* queue.c                                                           *
*********************************************************************
* Written by Mike Chase                                             *
* Written on March 02, 2006                                         *
*********************************************************************
* Purpose: An array-based implementation of a queue                 *
********************************************************************/

#include "global.h"
#include "queue.h"

int* _queue;
int _head = 0;
int _tail = 0;
int _size = -1;

// Create a queue with given upper bound on size
void createQueue(int maxSize)
{
	int i = 0;

	_size = maxSize;
	_queue = (int *)calloc( (size_t)maxSize, sizeof(int) );
	for (i = 0; i < _size; i++)
	{
		_queue[i] = -1;
	}
}

// Destory the queue
void destroyQueue()
{
	//free(_queue);
}

// Check if the queue is empty or not
BOOL isQueueEmpty()
{
	if (_head == _tail)
		return TRUE;
	return FALSE;
}

// Get the item at the head of the queue
int queuePeek()
{
	if (_head == _tail)
		return -1;
	return _queue[_head];
}

// Remove the item at the head of the queue
int queuePop()
{
	int val;

	if (_head == _tail)
		return -1;

	val = _queue[_head];
	_head++;
	if (_head >= _size)
		_head = 0;
	return val;
}

// Add an item to the end of the queue
void queuePush(int item)
{
	_queue[_tail] = item;
	_tail++;
	if (_tail >= _size)
		_tail = 0;
}
