/********************************************************************
* settings.h                                                        *
*********************************************************************
* Written by Mike Chase                                             *
*********************************************************************
* Purpose: Providing a way to easily specify common data for a      *
* scheduling experiment in a single experiment definition file      *
* instead of running different experiments by a combination of      *
* command line trickery and recompiling the code with different     *
* parts of the code commented out.                                  *
********************************************************************/

#ifndef _SETTINGS_H_
#define _SETTINGS_H_

#include "global.h"

BOOL readSettingsFile(char* filename);

BOOL isSchedulingSuperblocks();
BOOL shouldRunLS();
BOOL shouldRunOptimal();
BOOL shouldPrintSchedule();
BOOL isLSForward();
char *getBaseDataPath();
BOOL speculate();

#endif

