
#include "global.h"
#include "stack.h"


STACK_t *
createStack( int n )
{
    STACK_t  *s;

    s = (STACK_t *)calloc( (size_t)1, sizeof(STACK_t) );

    s->stack = (int *)calloc( (size_t)n+1, sizeof(int) );
    s->on_stack = (BOOL *)calloc( (size_t)n+1, sizeof(BOOL) );
    s->top = 0;

    return( s );
}

void
destroyStack( STACK_t *s )
{
    free( s->stack );
    free( s->on_stack );
    free( s );
}

BOOL
stackEmpty( STACK_t *s )
{
   return( s->top == 0 );
}

void
push( int v, STACK_t *s )
{
    if( !(s->on_stack[v]) ) {
	s->top++;
	s->stack[s->top] = v;
	s->on_stack[v] = 1;
    }
}

int
pop( STACK_t *s )
{
    int	 v;

    v = s->stack[s->top];
    s->on_stack[v] = 0;
    s->top--;

    return( v );
}

